using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using IE = Interop.SHDocVw;
using AddinExpress.IE;
using mshtml;
using Microsoft.Crm.Sdk;
using Microsoft.Crm.SdkTypeProxy;
using System.Net;
using Microsoft.Crm.Sdk.Query;

namespace ADXIECRMAddOn
{
    /// <summary>
    /// Add-in Express for Internet Explorer Module
    /// </summary>
    [ComVisible(true), Guid("FF740034-D507-410F-B090-565E0E000D9E")]
    public class IEModule : AddinExpress.IE.ADXIEModule
    {
        public IEModule()
        {
            InitializeComponent();
            //Please write any initialization code in the OnConnect event handler
        }

        private ADXIEBarItem adxieBarItem1;

        private ADXIEHTMLDocEvents adxiehtmlDocEvents1;


        public IEModule(IContainer container)
        {
            container.Add(this);

            InitializeComponent();
            //Please write any initialization code in the OnConnect event handler
        }

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxiehtmlDocEvents1 = new AddinExpress.IE.ADXIEHTMLDocEvents(this.components);
            this.adxieBarItem1 = new AddinExpress.IE.ADXIEBarItem(this.components);
            // 
            // adxiehtmlDocEvents1
            // 
            this.adxiehtmlDocEvents1.SupportedEvents = AddinExpress.IE.ADXIEHTMLSupportedEvents.seTableRow;
            this.adxiehtmlDocEvents1.OnPropertyChange += new AddinExpress.IE.ADXIEHTMLEventObject_EventHandler(this.adxiehtmlDocEvents1_OnPropertyChange);
            // 
            // adxieBarItem1
            // 
            this.adxieBarItem1.BarType = "ADXIECRMAddOn.CrmBar";
            this.adxieBarItem1.LoadAtStartup = true;
            this.adxieBarItem1.MenuText = "Add-in Express Dynamics CRM Order View";
            this.adxieBarItem1.Title = "Add-in Express Dynamics CRM Order View";
            // 
            // IEModule
            // 
            this.Bars.Add(this.adxieBarItem1);
            this.HandleShortcuts = true;
            this.LoadInMainProcess = false;
            this.ModuleName = "ADXIECRMAddOn";

        }
        #endregion

        #region ADX automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void RegisterIEModule(Type t)
        {
            AddinExpress.IE.ADXIEModule.RegisterIEModuleInternal(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void UnregisterIEModule(Type t)
        {
            AddinExpress.IE.ADXIEModule.UnregisterIEModuleInternal(t);
        }

        [ComVisible(true)]
        public class IECustomContextMenuCommands :
            AddinExpress.IE.ADXIEModule.ADXIEContextMenuCommandDispatcher
        {
        }

        [ComVisible(true)]
        public class IECustomCommands :
            AddinExpress.IE.ADXIEModule.ADXIECommandDispatcher
        {
        }

        #endregion

        public IE.WebBrowser IEApp
        {
            get
            {
                return (this.IEObj as IE.WebBrowser);
            }
        }

        public mshtml.HTMLDocument HTMLDocument
        {
            get
            {
                return (this.HTMLDocumentObj as mshtml.HTMLDocument);
            }
        }

        private void OnPropertyChange(object sender, object eventObject)
        {
            if (eventObject is IHTMLEventObj2)
            {
                IHTMLEventObj2 eventObj = (IHTMLEventObj2)eventObject;
                if (eventObj.srcElement is IHTMLElement)
                {
                    IHTMLElement eventElement = (IHTMLElement)eventObj.srcElement;
                    if (eventElement.className == "ms-crm-List-SelectedRow")
                    {
                        string id = eventElement.getAttribute("oid").ToString();

                        CrmAuthenticationToken token = new CrmAuthenticationToken();
                        token.AuthenticationType = 0;
                        token.OrganizationName = "NorthwindTraders";

                        using (CrmService service = new CrmService())
                        {
                            service.Url = "http://crmserver:5555/mscrmservices/2007/crmservice.asmx";
                            service.CrmAuthenticationTokenValue = token;
                            service.Credentials = new NetworkCredential("Administrator", "Password1", "CRMSERVER");

                            contact crmContact = (contact)service.Retrieve(EntityName.contact.ToString(), new Guid(id), new AllColumns());

                            Customer cust = crmContact.parentcustomerid;

                            ConditionExpression condition = new ConditionExpression();
                            condition.AttributeName = "customerid";
                            condition.Operator = ConditionOperator.Like;
                            condition.Values = new string[] { cust.Value.ToString() };

                            FilterExpression filter = new FilterExpression();

                            // Set the properties of the filter.
                            filter.FilterOperator = LogicalOperator.And;
                            filter.Conditions.Add(condition);

                            // Create the QueryExpression object.
                            QueryExpression query = new QueryExpression();

                            // Set the properties of the QueryExpression object.
                            query.EntityName = EntityName.salesorder.ToString();
                            query.ColumnSet = new AllColumns();
                            query.Criteria = filter;

                            // Retrieve the contacts.
                            BusinessEntityCollection orders = service.RetrieveMultiple(query);

                            ((CrmBar)this.Bars[0].BarObj).lblNumberOfOrders.Text = cust.name + " has " + orders.BusinessEntities.Count.ToString() + " orders.";
                            ((CrmBar)this.Bars[0].BarObj).lvOrders.Items.Clear();
                            foreach (salesorder order in orders.BusinessEntities)
                            {
                                ListViewItem lvItemOrderNum = new ListViewItem(order.ordernumber);
                                ListViewItem.ListViewSubItem lvItemTotal = new ListViewItem.ListViewSubItem(lvItemOrderNum, order.totalamount.Value.ToString("c"));
                                ListViewItem.ListViewSubItem lvItemName = new ListViewItem.ListViewSubItem(lvItemOrderNum, order.name);
                                lvItemOrderNum.SubItems.Add(lvItemTotal);
                                lvItemOrderNum.SubItems.Add(lvItemName);
                                ((CrmBar)this.Bars[0].BarObj).lvOrders.Items.Add(lvItemOrderNum);
                            }
                        }
                    }
                }
            }
        }

        private void adxiehtmlDocEvents1_OnPropertyChange(object sender, object eventObject)
        {
            if (eventObject is IHTMLEventObj2)
            {
                IHTMLEventObj2 eventObj = (IHTMLEventObj2)eventObject;
                if (eventObj.srcElement is IHTMLElement)
                {
                    IHTMLElement eventElement = (IHTMLElement)eventObj.srcElement;
                    if (eventElement.className == "ms-crm-List-SelectedRow")
                    {
                        string id = eventElement.getAttribute("oid").ToString();

                        CrmAuthenticationToken token = new CrmAuthenticationToken();
                        token.AuthenticationType = 0;
                        token.OrganizationName = "NorthwindTraders";

                        using (CrmService service = new CrmService())
                        {
                            service.Url = "http://crmserver:5555/mscrmservices/2007/crmservice.asmx";
                            service.CrmAuthenticationTokenValue = token;
                            service.Credentials = new NetworkCredential("Administrator", "Password1", "CRMSERVER");

                            contact crmContact = (contact)service.Retrieve(EntityName.contact.ToString(), new Guid(id), new AllColumns());

                            Customer cust = crmContact.parentcustomerid;

                            ConditionExpression condition = new ConditionExpression();
                            condition.AttributeName = "customerid";
                            condition.Operator = ConditionOperator.Like;
                            condition.Values = new string[] { cust.Value.ToString() };

                            FilterExpression filter = new FilterExpression();
                            filter.FilterOperator = LogicalOperator.And;
                            filter.Conditions.Add(condition);

                            QueryExpression query = new QueryExpression();
                            query.EntityName = EntityName.salesorder.ToString();
                            query.ColumnSet = new AllColumns();
                            query.Criteria = filter;

                            BusinessEntityCollection orders = service.RetrieveMultiple(query);

                            ((CrmBar)this.Bars[0].BarObj).lblNumberOfOrders.Text = String.Format("{0} has {1} orders.", cust.name, orders.BusinessEntities.Count);
                            ((CrmBar)this.Bars[0].BarObj).lvOrders.Items.Clear();
                            foreach (salesorder order in orders.BusinessEntities)
                            {
                                ListViewItem lvItemOrderNum = new ListViewItem(order.ordernumber);
                                ListViewItem.ListViewSubItem lvItemTotal = new ListViewItem.ListViewSubItem(lvItemOrderNum, order.totalamount.Value.ToString("c"));
                                ListViewItem.ListViewSubItem lvItemName = new ListViewItem.ListViewSubItem(lvItemOrderNum, order.name);
                                lvItemOrderNum.SubItems.Add(lvItemTotal);
                                lvItemOrderNum.SubItems.Add(lvItemName);
                                ((CrmBar)this.Bars[0].BarObj).lvOrders.Items.Add(lvItemOrderNum);
                            }
                        }
                    }
                }
            }
        }
    }
}

